<template>
  <div class="q-pa-md lightning-dashboard">
    <div class="start-timer">
      <q-btn @click="startTimer" icon="play_arrow" />
    </div>
    <div class="countdown">
      <CircularCountdown
        :startTime="startTime"
        :endTime="endTime"
        :disabled="startTime === null"
      />
    </div>

    <q-btn @click="messageTeamsAndMoveOn" label="Finalise round" />
    <div v-if="error !== null">
      <div class="error">error - {{ error }}</div>
    </div>
  </div>
</template>

<script lang="ts" allowjs="true">
import Vue from "vue";
import {
  ZoomSenseClientFirebaseDB,
  typedVuefirePlugin,
} from "@zoomsense/zoomsense-firebase";
import {
  getCurrentQuestionId,
  getTeamSubmittedAnswers,
  getCurrentQuestionTime,
  messageAllTeams,
} from "./messageTeams";
import CircularCountdown from "./CircularCountdown.vue";

Vue.use(typedVuefirePlugin);

export default Vue.extend({
  name: "Dashboard",
  data() {
    return {
      error: null as null | string,
      startTime: null as null | number,
      endTime: null as null | number,
    };
  },
  props: {
    firebase: {
      required: true,
      type: Object as () => ZoomSenseClientFirebaseDB,
    },
    context: {
      required: true,
      type: Object as () => {
        meetingid: string;
      },
    },
  },
  watch: {
    firebase: {
      immediate: true,
      async handler() {
        if (!this.context.meetingid) return;
      },
    },
  },
  methods: {
    setError(error: string) {
      this.error = error;
    },
    clearError() {
      this.error = null;
    },
    async messageTeamsAndMoveOn() {
      this.clearError();
      let result = await this.messageTeams();
      if (result) {
        this.setError(result);
        return;
      }
      result = await this.moveToNextRound(this.context.meetingid, Date.now());
      if (result) {
        this.setError(result);
      }
    },
    async messageTeams(): Promise<string | undefined> {
      const currentQuestion = await getCurrentQuestionId(
        this.context.meetingid,
        this.firebase
      );
      if (!currentQuestion) {
        return "Could not find current question";
      }
      let submittedAnswers = (
        await this.firebase
          .ref(
            `data/plugins/lightning-round/${this.context.meetingid}/${currentQuestion}/answers`
          )
          .once("value")
      ).val();
      if (!submittedAnswers) {
        submittedAnswers = {};
      }
      const teamAnswers = getTeamSubmittedAnswers(submittedAnswers);
      await messageAllTeams(this.context.meetingid, this.firebase, teamAnswers);
    },
    async moveToNextRound(
      meetingId: string,
      timestamp: any
    ): Promise<string | undefined> {
      // find current section
      const result = (
        await this.firebase.ref(`/config/${meetingId}/current`).once("value")
      ).val();
      if (!result) {
        return "Could not find current section in config";
      }
      // update db to be in next section
      await this.firebase
        .ref(`zoomSenseSchedule/meeting/${meetingId}/job`)
        .push({
          timestamp,
          meetingId,
          path: `config/${meetingId}/current/currentSection`,
          value: result.currentSection + 1,
        });
    },

    async startTimer() {
      getCurrentQuestionTime(this.context.meetingid, this.firebase).then(
        (time) => {
          console.log(time);
          if (!time) {
            return;
          }
          this.startTime = Date.now();
          this.endTime = this.startTime + time * 1000;
        }
      );
    },
  },
  components: { CircularCountdown },
});
</script>
<style>
.start-timer {
  margin-right: 30px;
  display: flex;
}
.error {
  font-size: 20px;
  font-weight: bold;
  color: red;
  margin-top: 20px;
}
.lightning-dashboard {
  display: flex;
  flex-direction: row;
  max-height: 100px;
}
.countdown {
  width: 4rem;
  padding-bottom: 30px;
  margin-right: 60px;
}
</style>
